searchNodes=[{"ref":"TimeMachinex.html","title":"TimeMachinex","type":"module","doc":"Define a generic clock api"},{"ref":"TimeMachinex.html#now/1","title":"TimeMachinex.now/1","type":"function","doc":"Return the current time from the configured adapter Options are: precision: :microsecond | :millisecond | :second, default: microsecond Examples iex&gt; TimeMachinex.now ~U[2019-12-16 00:35:07.571Z]"},{"ref":"TimeMachinex.html#utc_now/1","title":"TimeMachinex.utc_now/1","type":"function","doc":"Return the current time from the configured adapter Options are: precision: :microsecond | :millisecond | :second, default: microsecond Examples iex&gt; TimeMachinex.utc_now ~Z[2019-12-16 00:35:11.422092]"},{"ref":"TimeMachinex.Adapter.html","title":"TimeMachinex.Adapter","type":"behaviour","doc":"Clock behaviour definition"},{"ref":"TimeMachinex.Adapter.html#c:now/0","title":"TimeMachinex.Adapter.now/0","type":"callback","doc":"Returns the current datetime in UTC."},{"ref":"TimeMachinex.Adapter.html#c:utc_now/0","title":"TimeMachinex.Adapter.utc_now/0","type":"callback","doc":"Returns the current UTC datetime."},{"ref":"TimeMachinex.ManagedClock.html","title":"TimeMachinex.ManagedClock","type":"module","doc":"Programmable clock"},{"ref":"TimeMachinex.SystemClock.html","title":"TimeMachinex.SystemClock","type":"module","doc":"System clock implementation"},{"ref":"readme.html","title":"TimeMachinex","type":"extras","doc":"TimeMachinex"},{"ref":"readme.html#installation","title":"TimeMachinex - Installation","type":"extras","doc":"If available in Hex, the package can be installed by adding time_machinex to your list of dependencies in mix.exs: def deps do [ {:time_machinex, &quot;~&gt; 0.3.0&quot;} ] end"},{"ref":"readme.html#introduction","title":"TimeMachinex - Introduction","type":"extras","doc":"TimeMachinex is just a managed clock around the system clock which works with DateTime.t() types. Configuration Configuring TimeMachine is very simple. What you generally want to do is to configure the SystemClock for :prod and :dev env: config :time_machinex, TimeMachinex, adapter: TimeMachinex.SystemClock and the ManagedClock in the :test env: config :time_machinex, TimeMachinex, adapter: TimeMachinex.ManagedClock Usage Whenever you need the current system time just replace the standard DateTime.utc_now/0 call with a TimeMachinex.utc_now/0 or TimeMachinex.utc_now/1 call. Please note that utc_now returns an UTCDateTime type. (Please use now/0 and now/1 if you need a standard DateTime) In :prod and :dev this will have no real side effects, since the now/0 function is just an alias for the DateTime.utc_now/0 thanks to the inline compilation attribute. The magic happens in the :test environment since the TimeMachinex.ManagedClock adapter will kick in (if configured properly). The only thing you need to do in your tests is to start the ManagedClock: ex(1)&gt; TimeMachinex.ManagedClock.start() {:ok, #PID&lt;0.190.0&gt;} when it starts it is configured with the current time: iex(2)&gt; TimeMachinex.ManagedClock.utc_now() ~Z[2019-12-16 14:34:32.623987] but now all the calls to TimeMachinex.utc_now/0 will read the time from the ManagedClock iex(3)&gt; TimeMachinex.utc_now() ~Z[2019-12-16 14:34:32.623987] which means that you can manipulate, simulate the time passing and test the time used in your production code. And yes, you stopped the time! iex(4)&gt; TimeMachinex.utc_now() ~Z[2019-12-16 14:34:32.623987] iex(5)&gt; TimeMachinex.utc_now() ~Z[2019-12-16 14:34:32.623987] If you want to update the TimeMachinex with the current time again (to simulate time passing) you can just: iex(7)&gt; TimeMachinex.ManagedClock.set() :ok iex(8)&gt; TimeMachinex.utc_now() ~Z[2019-12-16 14:38:04.255975] or you may just want to set a specific time and wait for Marty McFly: iex(9)&gt; ~N[1985-10-26 09:00:00] |&gt; DateTime.from_naive!(&quot;Etc/UTC&quot;) |&gt; TimeMachinex.ManagedClock.set() :ok iex(10)&gt; TimeMachinex.utc_now() ~Z[1985-10-26 09:00:00] Happy time travel!"},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#0-3-0","title":"Changelog - 0.3.0","type":"extras","doc":"Added utc support via :utc_datetime Default precision: :microsecond (align with elixir defaults)"},{"ref":"changelog.html#0-2-0","title":"Changelog - 0.2.0","type":"extras","doc":"Added precision support"},{"ref":"changelog.html#0-1-0","title":"Changelog - 0.1.0","type":"extras","doc":"Initial import"},{"ref":"license.html","title":"MIT License","type":"extras","doc":"MIT License Copyright (c) 2018 SQUARE ENIX LTD. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."}]